<?php
  $slug = @$params['slug'];
  $is_ajax = !isset($params['ajax']) || $params['ajax'];
  $addtags = isset($params['addTags']) ? preg_split('/\s*,\s*/', trim($params['addTags'])) : null;
  $reqtags = trim(@$_REQUEST['tags']) ? preg_split('/\s+/',trim($_REQUEST['tags'])) : null;

  // read tag file
  if (!file_exists(GSDATAOTHERPATH . I18N_WORD_INDEX)) create_i18n_search_index();
  $alltags = array();
  $f = fopen(GSDATAOTHERPATH . I18N_TAG_INDEX, "r");
  while (($line = fgets($f)) !== false) {
    $items = preg_split("/\s+/", trim($line));
    $tag = array_shift($items);
    $alltags[$tag] = $items; // slugs or plugin specific ids
  }
  fclose($f);
  ksort($alltags);

  // get all URLs or all URLs that have one of the "addTags"
  $allurls = null;
  if ($addtags) {
    foreach ($addtags as $tag) {
      if (isset($alltags[$tag])) {
        $allurls = $allurls ? array_values(array_intersect($allurls, $alltags[$tag])) : $alltags[$tag];
      } else {
        $allurls = array();
      }
    }
  } else {
    $allurls = array();
    foreach ($alltags as $tag => &$urls) {
      foreach ($urls as $url) {
        if (!in_array($url, $allurls)) $allurls[] = $url;
      }
    }
  }
  
  // get URLs that match the already selected tags
  $filteredurls = null;
  if ($reqtags) {
    foreach ($reqtags as $tag) {
      if (isset($alltags[$tag])) {
        $filteredurls = $filteredurls ? array_values(array_intersect($filteredurls, $alltags[$tag])) : $alltags[$tag];
      } else {
        $filteredurls = array();
      }
    }
  }

  $numPages = count($allurls);
  $diffPercent = $maxPercent - $minPercent;
  if (@$slug) {
    $pagedata = getXML(GSDATAPAGESPATH . $slug . '.xml');
    $link = find_url($slug, (string) $pagedata->parent);
    $link .= (strpos($link,'?') !== false ? '&' : '?') . 'tags=';
  }
  foreach ($alltags as $tag => &$urls) {
    if (substr($tag,0,1) == '_') continue;
    if ($addtags && count(array_intersect($urls, $allurls)) <= 0) continue;
    $unavailable = $filteredurls && count(array_intersect($urls, $filteredurls)) <= 0;
    $classes = @$link || !$unavailable ? 'tag' : 'tag unavailable';
    echo (@$link ? '<a href="'.htmlspecialchars($link).urlencode($tag).'" ' : '<span ') .
         'style="font-size:'.(int)($minPercent + $diffPercent*count($urls)/$numPages).'%" class="'.$classes.'">' .
         htmlspecialchars(trim(preg_replace('/_+/',' ',$tag))) . 
         (@$link ? '</a> ' : '</span> ');
  }

